package com.example.afrishop_v3.models;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import javax.persistence.*;
import java.util.Date;

@MappedSuperclass
abstract class Model {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @JsonProperty
    protected Long id;

    @JsonIgnore
    Date createDate = new Date();

    public Long getId() {
        return id;
    }

    @JsonIgnore
    public String createdBy;

    @JsonIgnore
    public Date updateDate = new Date();

    @JsonIgnore
    public String updatedBy;
    @Version
    private int version;

    @JsonIgnore
    public boolean archived;

    @JsonIgnore
    public String archivedBy;

    @JsonIgnore
    public Date archivedDate = new Date();

    public void clearId(){
        id = null;
    }

}
